/// <reference types="react" />
import { ReactEditor } from '.';
import { CustomAnnotationProps, CustomDecorationProps, CustomElementProps, CustomMarkProps } from '../components/custom';
export default class ReactRendering {
    /**
     * Render an annotation `Range` object.
     */
    renderAnnotation(this: ReactEditor, props: CustomAnnotationProps): JSX.Element;
    /**
     * Render a decoration `Range` object.
     */
    renderDecoration(this: ReactEditor, props: CustomDecorationProps): JSX.Element;
    /**
     * Render an `Element` object.
     */
    renderElement(this: ReactEditor, props: CustomElementProps): JSX.Element;
    /**
     * Render a `Mark` object.
     */
    renderMark(this: ReactEditor, props: CustomMarkProps): JSX.Element;
}
//# sourceMappingURL=rendering.d.ts.map